/* Convert MSIE Favourites to HTML page */
/* Author: Brian D. Jones               */
/* Date:   10th Jan 97                  */
/* Email:  Brian_Jones@technologist.com */
// History:	18 May 97 Check for "URL=" since not always last line in file.
//          14 Jun 97 Long names which include blanks now supported.
//          26 Jul 97 Explorer 4.0 aware
//			13 Oct 97 Explorer 4.0 Outline added.
//			20 Nov 99 Change Web site URL.
//          26 May 2001 Sort entries.
//          26 May 2001 Make like an Applet for use in HTML Application GUI
//          14 Oct 2002 Generate XHTML complient output.

import java.io.*;
import java.util.*;
import java.applet.*;
import java.awt.*;
import java.net.*;
import com.ms.security.*;

public class Favorite extends Applet {
	public static String Version = "1.90";
	private static int level = 0;

    private static void ListDir( File Path , PrintStream Out) {
    String Names[] = Path.list();

	if (folderFirst) sortF(Names, Path);
	else sort(Names);

	if (level == 0)
		Out.println("<div id=\"Out" +level +"\">");
	else
		Out.println("<div id=\"Out" +level +"d\" style=\"display:None\">");
	level = level +1;
	Out.println("<dl>");
	for (int i=0; i < Names.length; i++) {
	    try {
		File temp = new File( Path, Names[i] );
		if ( temp.isDirectory() ) {
		    Out.println( "<dt><span id=\"Out" +level +"\" class=\"Outline\" style=\"cursor: hand\"><img src=\"" +iconPath +"urlfldr.gif\" width=\"16\" height=\"16\" id=\"Out" +level +"i\" class=\"Outline\" hspace=\"4\" alt=\"folder\" /> "+ HTML(temp.getName()) +"</span></dt><dd>" );

		    ListDir ( temp, Out );
		    Out.println( "</dd>" );
		}
		else if (temp.getName().endsWith(".url")) {
		    try {
			String BaseName = temp.getName();
			String sURL = null,
				sDesc = null,
				sAuthor = null,
				sWhatsNew = null,
				sAccessed = null, sModified = null;
			DataInputStream file = new DataInputStream( new FileInputStream( temp ));
			String Line= null;
			Date dateModified = null,
				dateAccessed = null;

			while ( file.available() > 0 ) {
			    Line = file.readLine();
//				if (Line.startsWith("URL=")) break; // Not always last line.
				if (Line.startsWith("URL="))
					sURL = Line.substring( Line.indexOf( "=" )+1);
//				These items appeared in the Beta, but don't seem to be in the final version.
				if (Line.startsWith("Desc="))
					sDesc = Line.substring( Line.indexOf( "=" )+1);
				if (Line.startsWith("Author="))
					sAuthor = Line.substring( Line.indexOf( "=" )+1);
				if (Line.startsWith("WhatsNew="))
					sWhatsNew = Line.substring( Line.indexOf( "=" )+1);
				if (Line.startsWith("Accessed="))
					sAccessed = Line.substring( Line.indexOf( "=" )+1);
				if (Line.startsWith("Modified="))
					sModified = Line.substring( Line.indexOf( "=" )+1);
			}
			file.close();
//			Line = Line.substring( Line.indexOf( "=" )+1);
			BaseName = BaseName.substring( 0, BaseName.lastIndexOf( "." ));
			Out.print( "<dt>");
			try {
				if (sModified != null) {
					String tmp = null;
					StringTokenizer token = new StringTokenizer( sModified, ",", false );
					tmp = token.nextToken().substring(2);
					dateModified = new Date( Long.parseLong(tmp,16));
//					Out.println(" Modified: " +dateModified.toLocaleString());
				}
				if (sAccessed != null) {
					String tmp = null;
					StringTokenizer token = new StringTokenizer( sAccessed, ",", false );
					tmp = token.nextToken().substring(2);
					dateAccessed = new Date( Long.parseLong(tmp,16));
//					Out.println(" Modified: " +dateAccessed.toLocaleString());
				}
			}
			catch ( Exception e ) { Out.println( "<!-- " +e +" -->");}
			Out.print( "<a href=\"" + httpURL(sURL) +"\">");
			if ( dateAccessed != null
				&& dateModified != null
				&& dateAccessed.after(dateModified))
				Out.print( "<img src=\"" + iconPath + "urlchg.gif\" width=\"16\" height=\"16\" border=\"0\" hspace=\"4\" alt=\"changed\" />");
			else
				Out.print( "<img src=\"" + iconPath + "url.gif\" width=\"16\" height=\"16\" border=\"0\" hspace=\"4\" alt=\"url\" />");
			Out.print( "</a> <a href=\"" + httpURL(sURL) +"\">");
			Out.println( HTML(BaseName) +"</a></dt>");
			if (sWhatsNew != null)
				Out.println("<dd>What's new: " +HTML(sWhatsNew) +"</dd>");
			else if (sDesc != null )
				Out.println("<dd>" +HTML(sDesc) +"</dd>");
		    }
		    catch ( Exception e ) { Out.println( "<!-- " +e +" -->");
		    }
		}
		else if (temp.getName().equalsIgnoreCase("desktop.ini")) {
		    try {
			String BaseName = Path.getName();
			String sURL = null,
				sLogo = "" + iconPath +"url.gif",
				sWideLogo = null;
			DataInputStream file = new DataInputStream( new FileInputStream( temp ));
			String Line= null;

			while ( file.available() > 0 ) {
			    Line = file.readLine();
//				if (Line.startsWith("URL=")) break; // Not always last line.
				if (Line.startsWith("CDFURL="))
					sURL = Line.substring( Line.indexOf( "=" )+1);
				if (Line.startsWith("Logo="))
					sLogo = Line.substring( Line.indexOf( "=" )+1);
				if (Line.startsWith("WideLogo="))
					sWideLogo = Line.substring( Line.indexOf( "=" )+1);
			}
			file.close();
			if (sURL != null) {
				Out.print( "<dt><a href=\"" +httpURL( sURL) +"\">");
				if (sWideLogo != null)
					Out.print( "<img src=\"" +httpURL(sWideLogo) +"\" alt=\"logo\" />");
				else
					Out.print( "<img src=\"" +httpURL(sLogo) +"\" alt=\"logo\" />");
				Out.println("</a></dt>");
			}
		    }
		    catch ( Exception e ) { Out.println( "<!-- " +e +" -->");
		    }
		}
	    }
	    catch ( Exception e ) { Out.println( "<!-- " +e +" -->");
								continue;
	    }
	}
	Out.println("</dl>");
	Out.println("</div>");
    }

    public static void DoIt( String Path, PrintStream Out ) {

	File Root = null;

	Out.println("<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\"");
	Out.println("\"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">");
	Out.println("<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"en\" lang=\"en\">");

	try {
		Root = new File( Path );
	}
	catch  ( Exception e ) {
		Out.println("<html><head><title>404 Not Given</title></head>");
		Out.println("<body><h1>404 Not Given</h1><p>No path was requested.</p></body></html>");
		return;
	}
	if ( !Root.exists()
	|| !Root.isDirectory()) {
		Out.println("<html><head><title>404 Not Found</title></head>");
		Out.println("<body><h1>404 Not Found</h1><p>The requested path <em>" +Path +"</em> was not found on this server</p></body></html>");
		return;
	}

	Out.println("<head>");
	Out.println( "<title>" +Root.getName() +"</title>");
	Out.println("<meta http-equiv=\"content-type\" content=\"text/html; charset=iso-8859-1\" />");
	Out.println("<meta name=\"author\" content=\"Brian D Jones\" />");
	Out.println("<meta name=\"robots\" content=\"all\" />");
	Out.println("<meta name=\"MSSmartTagsPreventParsing\" content=\"true\" />");
	Out.println("<meta name=\"description\" content=\"xhtml listing of" + Root.getName() + "\" />");
	Out.println("<meta name=\"keywords\" content=\"favorites, html," + Root.getName() + "\" />");

	Out.println("<script language=\"JavaScript\" type=\"text/javascript\">");
	Out.println("<!--");
	Out.println("function clickHandler() {");
	Out.println("  var targetId, srcElement, targetElement, srcId;");
    Out.println("  if (window.event) srcElement = window.event.srcElement;");
    Out.println("  else srcElement = clickHandler.arguments[0].target;");
	Out.println("  if (srcElement.className == \"Outline\") {");
	Out.println("     srcId = srcElement.id");
	Out.println("     if (srcElement.tagName.toLowerCase() == \"img\")");
	Out.println("        srcId = srcId.substr(0,srcElement.id.length-1);");
	Out.println("     targetId = srcId + \"d\";");
    Out.println("     if (document.getElementById) targetElement = document.getElementById(targetId);");
    Out.println("     else if (document.all) targetElement = document.all(targetId);");
    Out.println("     else return;");
	Out.println("     if (targetElement.style.display == \"none\") {");
	Out.println("        targetElement.style.display = \"\";");
	Out.println("        document.images(srcId + \"i\").src = \"" + iconPath + "urlfldro.gif\";");
	Out.println("        setCookie( targetId, \"show\" );");
	Out.println("     } else {");
	Out.println("        targetElement.style.display = \"none\";");
	Out.println("        document.images(srcId + \"i\").src = \"" + iconPath + "urlfldr.gif\";");
    Out.println("        setCookie( targetId, \"none\" );");
	Out.println("     }");
	Out.println("  }");
	Out.println("}");
	Out.println("");
	Out.println("function setCookie(name, value) {");
	Out.println("  document.cookie = name + \"=\" + escape(value);");
	Out.println("}");
	Out.println("function readtree() {");
	Out.println("  var dc = document.cookie;");
	Out.println("  if (dc.length > 0) {");
	Out.println("    ca = dc.split(\";\");");
	Out.println("    for ( c in ca ) {");
	Out.println("      mid = ca[c].indexOf(\"=\");");
	Out.println("      if (ca[c].charAt(0) == \" \") targetId = ca[c].substring(1,mid)");
	Out.println("      else  targetId = ca[c].substring(0,mid)");
	Out.println("      if ( targetId.substr(0,3) != \"Out\") continue;");
	Out.println("      val = ca[c].substr(mid+1,4);");
	Out.println("      if (document.getElementById) targetElement = document.getElementById(targetId);");
	Out.println("      else if (document.all) targetElement = document.all(targetId);");
	Out.println("      else return;");
	Out.println("      if (val == \"show\") {");
	Out.println("        targetElement.style.display = \"\";");
	Out.println("        document.images(targetId.substr(0,targetId.length-1)+\"i\").src = \"" + iconPath + "urlfldro.gif\";");
	Out.println("      }");
	Out.println("    }");
	Out.println("  }");
	Out.println("}");
	Out.println("document.onclick = clickHandler;");
	Out.println("//-->");
	Out.println("</script>");
	Out.println("<style type=\"text/css\" media=\"all\">");
	Out.println(" body { font-family: Verdana, Geneva, Arial, Helvetica, sans-serif; font-size:10pt;}");
	Out.println(" .head { font-size:14pt; font-weight: bold;}");
	Out.println(" .OutLine { font-weight: bold; }");
	Out.println(" img {vertical-align : text-top;}");
	Out.println("</style>");
	Out.println( "</head>" );

	Out.print("<body onload=\"readtree();\">");
	Out.println( "<div class=\"head\"><img src=\"" + iconPath + "urlfldr.gif\" width=\"32\" height=\"32\" alt=\"folder\" />" +Root.getName() +"</div><hr />");

        ListDir( Root, Out );

	Out.println( "<hr />" );
	Out.println( "Created: " +new Date().toLocaleString() );
	Out.println( "using Java application v: " + Version + " created by <a href=\"http://www.jonessoft.pwp.blueyonder.co.uk\">Brian D. Jones</a>" );
	Out.println( "<a href=\"mailto:Brian_Jones@technologist.com\">Email: Brian_Jones@technologist.com</a>" );
    Out.print( "<a href=\"http://validator.w3.org/check/referer\"><img");
    Out.print( " src=\"http://www.w3.org/Icons/valid-xhtml10\"");
    Out.print( " alt=\"Valid XHTML 1.0!\" height=\"31\" width=\"88\" border=\"0\" /></a>");
	Out.println( "</body>" );
	Out.println( "</html>" );

    }

	private static String cmdLine( String args[]) {
		String returnString = args[0];
		for ( int i=1; i< args.length; i++) returnString = returnString +" " +args[i];
		return returnString;
	}

	private static boolean folderFirst = false;
	private static String iconPath = "/icons/";
	private static void sort( String toSort[]) {
		if (toSort.length<2) return;
		int i,j;
		for (i=0; i < toSort.length ; i++)
			for (j=i+1; j < toSort.length ; j++) 
				if (toSort[j].compareTo(toSort[i])< 0) {
					String temp = toSort[i];
					toSort[i] = toSort[j];
					toSort[j] = temp;
				}
	}

	private static void sortF( String toSort[], File Path) {
		if (toSort.length<2) return;
		int i,j;
		for (i=0; i < toSort.length ; i++) {
			File fileA = new File( Path, toSort[i] );
			for (j=i+1; j < toSort.length ; j++) {
				File fileB = new File( Path, toSort[j]);
				if ( (fileB.isDirectory() && fileA.isFile() )
				|| ( ((fileA.isDirectory() && fileB.isDirectory() )
				||   (fileA.isFile() && fileB.isFile()) )
				&& (toSort[j].compareTo(toSort[i])< 0) ) ) {
					String temp = toSort[i];
					toSort[i] = toSort[j];
					toSort[j] = temp;
					fileA = fileB;
				}
			}
		}
	}

	public void init()
    {
        setForeground( Color.black  );
        setBackground( Color.green  );
    }

	public void setOrder( boolean order ) {
		folderFirst = order;
	}
	public void setPath( String Path ) { 
		if (Path==null) iconPath = "";
		else iconPath = Path.replace('\\','/');
	}
	public void save(String folder, String toFile) {
	PolicyEngine.assertPermission(PermissionID.SYSTEM);
		FileOutputStream saveFile = null;
		level = 0;
		try {
			saveFile = new FileOutputStream (toFile) ;
		DoIt( folder, new PrintStream( saveFile ));
		saveFile.close();
		} catch (Exception e) {}
	}
    public static void main (String args[] ) {
	System.out.println("Content-type: text/html");
	System.out.println("");
	if (args.length < 1) {
		System.out.println("<html><head><title>404 Not Given</title></head>");
		System.out.println("<body><h1>404 Not Given</h1><p>No path was requested.</p></body></html>");
		return;
	}

	DoIt( cmdLine( args ), System.out );
    }
    public static String HTML(String s) {
        char[] specChars = new char[4];
        String[] specCharsRepl = new String[4];
        specChars[0] = '&'; specCharsRepl[0] = "amp;";    //escapeChar
        specChars[1] = '"'; specCharsRepl[1] = "quot;";
        specChars[2] = '<'; specCharsRepl[2] = "lt;";
        specChars[3] = '>'; specCharsRepl[3] = "gt;";
        return replSpecChars(s, specChars, specCharsRepl, '&');
    }
    public static String httpURL(String s) {
        char[] specChars = new char[17];
        String[] specCharsRepl = new String[17];       // Decimal
        specChars[0] = '%'; specCharsRepl[0] = "25";   // 37       //escapeChar
        specChars[1] = ' '; specCharsRepl[1] = "20";   // 32
        specChars[2] = '<'; specCharsRepl[2] = "3C";   // 60
        specChars[3] = '>'; specCharsRepl[3] = "3E";   // 62
        specChars[4] = '"'; specCharsRepl[4] = "22";   // 34
        specChars[5] = '#'; specCharsRepl[5] = "23";   // 35
        specChars[6] = '{'; specCharsRepl[6] = "7B";   // 123
        specChars[7] = '}'; specCharsRepl[7] = "7D";   // 125
        specChars[8] = '|'; specCharsRepl[8] = "7C";   // 124
        specChars[9] = '\\'; specCharsRepl[9] = "5C";  // 92
        specChars[10] = '^'; specCharsRepl[10] = "5E"; // 94
        specChars[11] = '~'; specCharsRepl[11] = "7E"; // 126
        specChars[12] = '['; specCharsRepl[12] = "5B"; // 91
        specChars[13] = ']'; specCharsRepl[13] = "5D"; // 93
        specChars[14] = '&'; specCharsRepl[14] = "26"; // 38
        specChars[15] = ';'; specCharsRepl[15] = "3B"; // 59
        specChars[16] = '?'; specCharsRepl[16] = "3F"; // 63
        return replSpecChars(s, specChars, specCharsRepl, '%');
    }

    static String replSpecChars(String input, char[] specChars, String[] specCharsRepl, char firstChar) {
        String out = null;
        if (input != null) {
            StringBuffer output = new StringBuffer(input);
            for (int i = 0; i < specChars.length; i++) {
                int index = output.toString().indexOf(specChars[i]);
                while (index != -1) {
                    output.setCharAt(index, firstChar);
                    output.insert(index + 1, specCharsRepl[i]);
                    index = output.toString().indexOf(specChars[i], index + 1 + specCharsRepl[i].length());
                }
            }
            out = output.toString();
        }
        return out;
    }
}

